Page MenuHome

Industry Compatible Keymap
Closed, ResolvedPublic

Tokens
"Burninate" token, awarded by anonym."Mountain of Wealth" token, awarded by merwin."Love" token, awarded by lkruel."Love" token, awarded by jbklug."Love" token, awarded by Njordy."Love" token, awarded by belmonthook."Love" token, awarded by Moctor."Love" token, awarded by Kartridge."Love" token, awarded by renatoi."Love" token, awarded by vitorbalbio."Like" token, awarded by Somnolent."Love" token, awarded by yrrnn."Love" token, awarded by solafide."Like" token, awarded by clawjelly."Love" token, awarded by d.viagi."Love" token, awarded by KartoonHead."Love" token, awarded by zaha."Love" token, awarded by TheFaceless."Love" token, awarded by oktawu."Love" token, awarded by Mitch."Love" token, awarded by pitom."Love" token, awarded by KloWorks."Love" token, awarded by fabioroldan."Love" token, awarded by elbox01."Love" token, awarded by wo262."Love" token, awarded by fiendish55."Love" token, awarded by undo."Like" token, awarded by Orv510."Love" token, awarded by juancahf."Burninate" token, awarded by shader."Love" token, awarded by sebastianmroy."Love" token, awarded by sopranoo."Love" token, awarded by zazizizou."Love" token, awarded by razgriz286."Love" token, awarded by jpthrash."Love" token, awarded by julperado."Love" token, awarded by Okavango."Love" token, awarded by johnsyed."Love" token, awarded by 0o00o0oo."Like" token, awarded by duarteframos.
Authored By

Description

This describes design of a new input map (keymap from now on) variant for Blender 2.8.

Motivation

In the past, we've included various alternative keymaps with Blender. While it has been of some use, we've had a few major problems:

  • The old keymaps couldn't properly mimic the way other apps use tools
  • The old keymaps were not well maintained. There were too many.
  • We used to include options for the Blender keymap, such as LMB select, which never worked properly for all tools and modes

In Blender 2.8, we want to improve this, by making one 'Industry Standard' keymap that we can keep well maintained, and in working order.

This new keymap will make switching back and forth between industry standard apps easier, and will provide a lower barrier to entry for migrating to Blender.


Note: Blender 2.8 includes various new features, such as Active Tools, which makes it possible to work a lot more like industry standard apps, if we choose. This enables us to mimic industry standard input more closely than we could in the past.


Approach

  • It will not replace the default keymap in Blender - this is an alternative keymap for users who use Blender as part of their pipeline, in conjunction with industry standard apps.
  • It should be a minimal, maintainable keymap. Not every command needs to be mapped to a shortcut like the Blender default keymap
  • The design of this keymap is based on an average of default input mapping layouts used in the mainstream computer graphics software

Who is this keymap for?

This keymap is for people who are already accustomed to other 3D packages, and who wish to use Blender as part of their pipeline, or who wish to switch to Blender outright. It is not aimed at existing Blender users, although they are free to use it if they wish.

The main use-case is switching quickly between many apps. Some users jump between Blender, Maya, Unity, Substance and other apps, so making Blender’s controls adhere more to these kinds of apps makes it easier to jump between them seamlessly.

The other use-case is for users of those other apps, to make it easier to learn how to use Blender. They may not wish to learn all Blender’s non-standard idiosyncrasies, but still take advantage of some of Blender’s features in their pipeline.

Tie Breaker App

Not all apps in the 3D industry agree on which shortcuts to use. In cases where no standard exists, we want to rely on a 'tie breaker' app which decides the hotkey. When the tie-breaker app has no hotkey set, we can use one of the other apps' hotkeys then.

These are the tie-breaker apps we have chosen:

Modeling & AnimationMaya
Painting & SculptingZbrush

Brief Overview

Refer to the manual for a brief overview of how this keymap works:
Industry Compatible keymap in manual

DCC App Research Chart

This spreadsheet gives clear insight into which keys are used in which apps.

3Ds MaxMayaCinema 4DModoHoudiniUnreal EngineUnityWinner
Viewport navigation
OrbitAlt+MMBAlt+LMBAlt+LMBAlt+LMBAlt+LMBAlt+LMBAlt+LMBAlt+LMB
PanMMBAlt+MMBAlt+MMBAlt+Shift+LMBAlt+MMBAlt+MMBAlt+MMBAlt+MMB
ZoomCtrl+Alt+MMBAlt+RMBAlt+RMBCtrl+Alt+LMBAlt+RMBAlt+RMBAlt+RMBAlt+RMB
Center on selectionZFOShift+ASpace+GFFF
Switch viewportsL, F, BSpaceF1-F5Ctrl+SpaceSpace+1-5Alt+J, Alt+K, Alt+HN/A ?
Selection
Select mode/toolQQN/AQSN/AN/AQ
SelectLMBLMBLMBLMBLMBLMBLMBLMB
Deselect???Click in empty spaceClick in empty space????????????Click in empty space
Add to selectionCtrl+LMBShift+LMBShift+LMBShift+LMBShift+LMBShift+LMBShift+LMBShift+LMB
Subtract from selectionAlt+LMBCtrl+LMBCtrl+LMBCtrl+LMBCtrl+LMBCtrl+LMBCtrl+LMBCtrl+LMB
Box selectDrag LMBDrag LMBDrag LMBDrag LMBDrag LMBDrag LMBDrag LMBDrag LMB
Add to box selectionCtrl+Drag LMBShift+Drag LMBShift+Drag LMBDrag LMBShift+Drag LMBShift+Drag LMBShift+Drag LMBShift+Drag LMB
Subtract from box selectionAlt+Drag LMBCtrl+Drag LMBCtrl+Drag LMBCtrl+Drag LMBCtrl+Drag LMBCtrl+Drag LMBCtrl+Drag LMBCtrl+Drag LMB
Loop Select???Double-click edgeDouble-click edge????????????Double-click edge
Menus
Context Sensitive CommandsRMBRMBRMBRMBRMBRMBRMBRMB
Transform tools
MoveWWEWTWWW
RotateEEREREEE
ScaleRRTRERRR
Mesh Editing
Mesh element modes1-5F9-F11Enter1-31-4N/AN/A1-9
ExtrudeShift+ECtrl+EDShift+XN/AN/AN/ACtrl+E
InsetN/AN/AiB (bevel mode)N/AN/AN/AI
Loop cutCtrl+Shift+EN/AK (knife tool mode)Alt+CN/AN/AN/AAlt+C
BevelCtrl+Shift+BN/AM+SBN/AN/AN/AB
Animation
Play/Pause/Alt+VF6/Up ArrowN/AN/ASpace
Set KeyframeKSSK S
ZbrushMudbox3D CoatModo
Sculpting
Resize BrushSB+click and drag?????????
IntensityUM+click and drag?????????
Blob tool???????????????
Smooth tool???Hold shift or 2(default)?????????
Snake Hook tool???????????????
Grab tool???????????????
Clay tool???????????????
Etc???????????????
ZbrushMudbox3D CoatModoMariSubstance Painter
Texture Painting
Resize BrushS???ctrl+RMB+drag left/right???R+any Mouse buttonctrl+RMB
IntensityU????????????ctrl+LMB+drag left/right´
Paint tool????????????P1
Eraser Tool????????????E2
colour pickerC???V???CP
Display next channel???????????????C
Display previous channel???????????????shift+C
Show Material???????????????M
SymmetryX???S??????L
wireview??????W???shift+W???
Swap foreground and background colorsV?????????XL
rotate environment??????shift +LMB+drag left/right??????shift+RMB
Set Clone tool source????????????ctrlctrl+LMB
Stencil rotate????????????ctrl+LMBS+LMB
Stencil snap rotate???????????????shift+S+LMB
stencil pan????????????shift+LMBS+MMB
stencil zoom????????????ctrl+shiftS+RMB

Testing

This keymap is now included with the Blender 2.8 beta.

Details

Type
To Do

Related Objects

Event Timeline

There are a very large number of changes, so older changes are hidden. Show Older Changes

Of course. Particle edit mode is not the same as Edit mode. 2,3,4 go directly to Edit mode

Ouch... I'd assume that the number keys will always toggle edit submodes of any mode you are in in the same order. At least that's how it works in all the other apps that use number keys to switch edit submodes :)

That cannot work in practice. Then there would be no way to switch to Edit Mode if you are inside Particle mode. The whole idea with using the number row for modes is that you can switch immediately and directly to whichever mode you wish. So the keys must keep working.

Yeah, I think Blender's default keys (Tab to enter/exit edit mode) are the best choice here. From my experience, most packages don't really use a quick search like Blender, so it seems logical to me to have something as commonly used as edit mode on a nicely accessible key like Tab.

So in that case, search could also stay on the spacebar. That seems like a logical button to press when you're about to start typing. Having animation playback on spacebar doesn't seem that critical to me, and I say that as an animator. I'd rather have playback mapped to something right near my framestep keys.

Escape is used to cancel running jobs (like shader compilation, render, baking), using that for object mode switching would conflict.

Particle mode will disappear, so I wouldn't worry about inconsistency there too much. Hair will become an object type with an edit mode and then it becomes consistent.

The selection modes thing is tricky because we want to match the industry standard, but then also the opinion seems to be that none of the main apps actually get it right?

  • Maya and C4D don't use number keys.
  • Modo in latest versions does not use it either as far as I can tell from the docs?
  • 3ds Max uses 123 but the way it switches to object mode with toggling is considered bad?
  • Houdini is the one that makes sense logically and ergonomically but is not considered standard enough.

To me 1-2-3-4 for vert-edge-face-object wouldn't be the worst thing, but it is odd to put object mode in the middle between edit and paint modes. I guess it would be mainly to help those familiar with 3ds Max, or am I missing someplace where this convention exists and is considered to work well?

Yep, another vote for the Tab key for object mode toggle. If quick search is an issue, then that one is equally as much found on Ctrl+Space or F1 keys in other apps. It'd made general sense, as 1-9 keys would be to enter different modes, and Tab key would be to exit any mode, so it's kind of a different type of key.

Otherwise, Tilde key is a good candidate. If Tilde is not available on all keyboards, then the Object mode key can be simply mapped multiple times for the other keys in place of tilde in other languages.

Escape is used to cancel running jobs (like shader compilation, render, baking), using that for object mode switching would conflict.
Particle mode will disappear, so I wouldn't worry about inconsistency there too much. Hair will become an object type with an edit mode and then it becomes consistent.
The selection modes thing is tricky because we want to match the industry standard, but then also the opinion seems to be that none of the main apps actually get it right?

  • Maya and C4D don't use number keys.
  • Modo in latest versions does not use it either as far as I can tell from the docs?
  • 3ds Max uses 123 but the way it switches to object mode with toggling is considered bad?
  • Houdini is the one that makes sense logically and ergonomically but is not considered standard enough.

To me 1-2-3-4 for vert-edge-face-object wouldn't be the worst thing, but it is odd to put object mode in the middle between edit and paint modes. I guess it would be mainly to help those familiar with 3ds Max, or am I missing someplace where this convention exists and is considered to work well?

MODO does, indeed, use the the 123 keys (actually uses 1-5) in the latest version (and has since several previous versions). I have a perpetual license of MODO and I use the number keys all the time. Their number key map is 1 - vertex, 2 - edge, 3 - face, 4 - material, 5 - object mode.

Using 1 for object mode is used by some other apps, and it’s also the default mode in Blender. Plus, it mirrors the same order you see in the Mode drop down menu. So I’ll keep it this way.

I am not sure where you get this but for me (and at least one other person who has commented here), in Blender 2.8, the app opens in object mode (because you normally begin by creating an object to work with). While in object mode, pressing 1, 2, or 3 on the number row does nothing. You press TAB to exit object mode and enter into item mode. At this point, pressing 1 brings you to vertex mode, 2 brings you to edge edit mode, and 3 is to select and edit faces. This is the default I get in Blender 2.8. Other than using TAB to switch between object and edit mode, it is already very close to how programs like MODO work (a key to get into edit mode and 1-3 keys, once in edit mode, to switch between vertex, edge, and face).

At the top, you have this chart that shows what other industry apps use and based on the majority, a winner (key combo) is declared. If you look at this chart under Mesh Editing, Mesh Element Modes, you will see that you have Max using keys 1-5, Maya using F9-F11, C4D using Enter, Modo using 1-3 (it actually uses 1-5), and Houdini using 1-4. The winner you declare? 1-9! Yet NONE of the apps use 1-9! In the process of trying to create an industry standard, with the emphasis being on helping people that use these other programs migrate over to Blender more easily, you decide to do something DIFFERENT instead of the "industry standard" From looking at the chart, it is clear that most everyone is doing things a bit differently. But three of the apps use at least the 1-4 keys (Max, Modo, and Houdini) and two of them (at least?) use 1-3 the same (Max and Modo). So, why go against the majority in favor of doing something different?

My proposal (and, apparently, that of many others here) is to simply leave it at the current Blender 2.8 default - TAB toggles between object and edit mode. When in edit mode, 1 - vertex, 2 - edge, 3 - face. It's simple. It follows what Blender already does. And it (mostly) matches the industry standard according to your own chart.

As @Brecht Van Lommel (brecht) nicely summarized the situation, there seems to be no commonly agreed standard here. I get the feeling that any change to the default Blender keymap does not add anything worthwile to improve the situation, so I wonder if this change is needed in the first place? This discussion starts to remind me of this xkcd: https://xkcd.com/927/

Please do not forget there are some users for this keymap that are already Blender users who work alot with complementary industry-standard tools like Substance Painter, Unreal Engine 4, Unity, Houdini, ZBrush, .... I am one of those people and what I hope to get from this keymap is an easier switching between programs since Blender is the big outlier here (except for ZBrush maybe :D). This is mostly achieved by using Maya-style Navigation in the viewport and using the QWER keys for transformations. Most other Blender shortkeys would be fine for me, to be honest. I don't care whether mode switching is on TAB or 1-4 in whatever order, as long as it allows for a good user experience. What I need is an efficient keymap that is not too disrupting to the complementary applications making it easier to switch between them. It also has to offers a convenient shortcuts for everything that is needed for daily work (the industry compatible keymap is currently lacking in that regard IMHO).

Do you consider such users a target audience for this keymap @William Reynish (billreynish) or is it only focussed on making the transition easier for non-blender artists who want to switch application coming from MAX/Maya/C4D and so on? Maybe we should first get the target audience straight before discussing any further.

Do you consider such users a target audience for this keymap @William Reynish (billreynish) or is it only focussed on making the transition easier for non-blender artists who want to switch application coming from MAX/Maya/C4D and so on? Maybe we should first get the target audience straight before discussing any further.

Right at the top of the page it states the following:

"In Blender 2.8, we want to improve this, by making one 'Industry Standard' keymap that we can keep well maintained, and in working order.

This new keymap will make switching back and forth between industry standard apps easier, and will provide a lower barrier to entry for migrating to Blender."

So, it looks like they have the target audience(s) already figured out. ;)

Do you consider such users a target audience for this keymap @William Reynish (billreynish) or is it only focussed on making the transition easier for non-blender artists who want to switch application coming from MAX/Maya/C4D and so on? Maybe we should first get the target audience straight before discussing any further.

Right at the top of the page it states the following:
...

Ha, right. Thanks for pointing that out, my bad! 😅

Well then that shortens my argument to: Is it really worth to change this from the default Blender keymap?
There have been arguments that it is already close to the industry standard (1-3 keys for vertex to face selection, whether pressing any of those should also switch immediately into Edit Mode is open for discussion. Both are possible.) and people seem to like that more than going for something completely different.

The issue of where to put the operator search then should be handled separately and not mixed up in this discussion IMHO, as the benefit of a good mode selection far outweights the operator search. Could be put on CTRL + F which is THE industry standard for search anyway.

@Dan Silverman (ArgentArts), note we are talking about the Industry Compatible Keymap here, which is not the default Blender keymap. We have no plans to change mode switching in the default keymap.

@Dan Silverman (ArgentArts), note we are talking about the Industry Compatible Keymap here, which is not the default Blender keymap. We have no plans to change mode switching in the default keymap.

I've only been talking about and making suggestions about the industry keymap. I've only brought up the default Blender keymap as an example (and to say that even in the industry compatible keymap that we should keep the Blender default for object/edit mode (tab) and 1-3 for item editing modes).

As an outsider user (I love learning new software, Maya, Modo, Max) I agree that Blender’s mode switching implementation worked fine and was already very similar to the standard so maybe we should just keep it.

I’m just now trying to learn Blender because of the 2.80 hype and I can see the benefits of keeping it unchanged. I like that in Edit mode the number keys switch components, but in object mode you can use them to switch collections instead (reminiscent on how you can reuse keys in Modo depending on the context).

Another use for TAB being a toggle is that you get to turn modifiers on and off with a single key to see before and after (unsubdivided/subdivided for example)

I would encourage people to test these things out a little first, you might end up agreeing.

If you’ve ever tried learning different software you will know that a few keymap changes work wonders for learning it, but some defaults should be embraced because of how the software was designed to work. You might win a little comfort by changing those but you lose a little functionality too.

NOTE
Don’t forget that we can always change or add our own personal hotkeys, so don’t be sad if the hotkey you suggest doesn’t make it into one of the presets. We can make our own presets and share them and, if they’re good enough, they might end up as part of the built in presets one day, WHO KNOWS?

Dan Pool (dpdp) added a comment.EditedApr 17 2019, 5:40 PM

I found a great way to have the keybindings w, e, and r trigger the active tools (I won't restate my opinion of why this is bad if you're trying to attract users of other software) as well as the traditional blender way of doing transforms. Set move to W with a Click Drag value. This way tapping the W key activates the tool (this should really just toggle the gizmo imo) and moving the mouse while the w key is pressed goes directly into moving the object. I think a lot of new users will like this behavior since it's so much faster than working with gizmos, but will likely not stumble on it with the industry compatible keymap as-is.

Edit: I'd like to chime in on the edit mode keybindings. I think Tab is a better choice, but see the drawbacks that billrey brings up as being valid. It would be nice if the Tab key was context aware.

@William Sitton (william) Reynish (billreynish)

Edge Ring Selection comparsion and suggestion.
As I write before the way to go for edge ring select should be like maya, mainly because we chose the same navigation shortcut.
In my opinion we can set shift + double click as "Select Next Element" but we need something like INFINITE option in order to complete the loop/ring action. Ctrl + double click should deselect in the same way.

Maya

My proposal

To me 1-2-3-4 for vert-edge-face-object wouldn't be the worst thing, but it is odd to put object mode in the middle between edit and paint modes. I guess it would be mainly to help those familiar with 3ds Max, or am I missing someplace where this convention exists and is considered to work well?

We could easily do it, but it’s just awkward for other types that don’t have vert/edge/face modes.

We maybe could make it so that if you have a curve selected, either 1,2 or 3 will simply go to edit mode, even though that would be rather strange.

I really think It's a good start, but ...

  1. TAB to enter in edit mode and exit edit mode it's ok to keep it .
  2. I think 1, 2, 3 for Vertex, Edge, Faces selection it's ok to keep also. ( or if you want to do it like in maya, do a pie-menu for Vertex, edge, faces selection bind it on right-click )
  3. Ctrl + B for Bridge, X - for Knife, - I know it's K ... but it's usually ok to keep the most used keys where you are keeping your hands when you model. ( coming for a right hand on mouse, left hand on keyboard ) ... X comes more natural then K .

I will probably tune the IC Keymap to my liking anyway but for what it's worth this is my take on the keymap.

I vote for this setup:

1 ... vertices
2 ... edges
3 ... faces

It kind of makes sense and is easy to remember (especially for beginners) because:

1 ... a vertex is defined by just 1 point
2 ... an edge is defined by 2 points
3 ... a face is defined by at least 3 points

Hitting any of these keys should also take you automatically to the Edit mode regardless of the mode you are in. This is how it currently works in the IC Keymap, which is good - so please don't change it.
(I think the default Blender keymap would benefit from this behavior too but that is for another discussion.)

As for the Object mode key, the Tab key would be fine with me. Or the key before the 1 (the first key in the row).

I probably wouldn't like the 1, 2, 3 keys to also be toggles (they should not take you to the Object mode) like in 3ds max. But I am not entirely sure, I would have to test this for a period of time to be sure.

And as far as other objects like NURBS curves are concerned, hitting 1 or 2 or 3 would take you to the Edit mode. I see no problem with this behavior.

Then, of course, the current Mode-drop-down-menu (in the viewport) will not make much sense. But I think this whole system should be redesigned (now I am talking about Blender's UI and UX as a whole, not just the IC Keymap). For example in the Blender default keymap if I am in the Object mode and want to quickly manipulate vertices why do I have to go to the Edit Mode first and only then I can switch to vertices? Why not to go directly to vertices in one key press? Why two steps instead of one? This kind of switching is needed very often and should be as fast as possible. Quickly switching to say Weight Paint Mode is not as important as this.

@Jaroslav Brudna (r4p7or_3D) (sorry for offtopic) Hey, if you want the functionality you propose straight away, without waiting, then this may help you: https://blenderartists.org/t/a-proper-keymap-for-blender-2-8/1145406

@Ludvik Koutny (rawalanche)

Thanks a lot, Ludvik! I definitely plan on diving into keymap (and Blender) tuning very soon. It is the only way to have full control (apart from doing your own builds :)). I am aware of your great work in this area. I have some of your (older) keymap threads bookmarked. Thanks for a link to this new one, I will certainly take a good look at it. If I have anything to say I will make comments over at blenderartist.
(End of offtopic from me too.)

@William Reynish (billreynish) Over easter I got around to really test the industry keymap on project. While overall okay, I quickly got the feeling it's slow and cumbersome compared to the default Blender keymap. I had to resort quite often to the search for some things that did not have shortcuts. Here are some suggestions to improve this for pro users:

Name Action Proposed ShortcutNotes
Edit & Object Mode Tools
AddVIEW3D_MT_add, VIEW3D_MT_mesh_addShift + A
Toggle SnapToolSettings.use_snapXTaken from Maya according to Google research
Transformation Tool Toggling
Toggle Move gizmoshow_gizmo_object_translateShift + WIt would be nice to toggle the visibility of the transform gizmos by adding Shift to the keys
Toggle Rotate gizmoshow_gizmo_object_rotateShift + E
Toggle Scale gizmoshow_gizmo_object_scaleShift + R
Selection Tools
Circle selectbuiltin.select_circleCtrl + QThe standard key for quitting the application should be Alt + F4 (which already works, too). If not possible Shift + Q could be used instead.
Lasso selectbuiltin.select_lassoAlt + Q
Cursor Tool
Reset/center cursor?Shift + C
Set 3D Cursor?Shift + RMBSince it's not conflicting with anything I recommended keeping this for speed reasons.

I like the active tools, but sometimes they are slow or no good fit for the job at hand. Therefore it would be super handy if you would allow direct usage of mesh editing tools by adding a modifier key to the shortcut. That would allow to keep the best of both worlds. My proposal would be Shift:

Name Action Proposed Shortcut
BevelMesh -> BevelShift + B
InsetMesh -> Inset FacesShift + I
Loop cutMesh -> Loop Cut and SlideShift + Alt + C
ExtrudeMesh -> Extrude and Move on NormalsShift + Ctrl + E
KnifeMesh -> Knife Topology ToolShift + K

Issues:

  • "Deselect All" is really strenuous to press with all keys being very close to each other.
Name Proposed ShortcutNotes
Deselect AllCtrl + Alt + A
Alternative
Select AllShift + AEven better, going with the convention of Shift is adding to a selection.
Deselect AllShift + Alt + A
  • Knife tool is acting really weird: As soon as you placed the first cut, it automatically adds more cuts whenever you cross any edge but if you click in the middle of a face it does not do anything. Might be that's intended? But IMHO it's really weird. Should work that it cuts whenever you left-click.

@Michael - (michael) Klement (zaha) Max uses "q" to just toggle all transform gizmos, it's pretty good.
Ctrl Q is a standard for quit for a lot of programs.
Ctrl A is an undisputed standard for select all everywhere.
I think Photoshop has the most comfortable deselect - Ctrl D

Dan Pool (dpdp) added a comment.EditedApr 23 2019, 10:20 PM

@Michael Klement (zaha) Instead of adding a modifier key, try using the Click Drag behavior for the operators. For instance, you can keep Ctrl+E (Press) for the extrude active tool and Ctrl+E (Click Drag) for the Mesh -> Extrude and Move on Normals operator. It works really well and is pretty intuitive it also gives the best of both worlds.

This is especially nice with the QWERT shortcuts, but wouldn't work as well with knife or loop cut.

@Cezary Szadejko (cez) the q key is select in 3ds Max. This is just like the q key in the industry compatible keymap except you can also hit q multiple times to choose your drag behavior in Blender.

i want to ask what id the real difference bewteen these two?, wouldn't be ideal to replace the Transform tools with the pop-over ones ,so they can be used with the industry hotkeys and work with other Active Tools epsecially selection tools and i beleive it will even bring 2.79 functioanlity to be easily toggleable....and the pop-over can remain for the other options.

@Michael Klement (zaha) Instead of adding a modifier key, try using the Click Drag behavior for the operators. For instance, you can keep Ctrl+E (Press) for the extrude active tool and Ctrl+E (Click Drag) for the Mesh -> Extrude and Move on Normals operator. It works really well and is pretty intuitive it also gives the best of both worlds.
This is especially nice with the QWERT shortcuts, but wouldn't work as well with knife or loop cut.


@Cezary Szadejko (cez) the q key is select in 3ds Max. This is just like the q key in the industry compatible keymap except you can also hit q multiple times to choose your drag behavior in Blender.

Oh wow, this is really nice! This achieves what I had in mind quite well, thanks for pointing it out.

Now getting this to work with Loop Cut and Knife would be really nice, because the active tool Loop Cut and Knife is really lacking for me right now. Using the tools panel to increase the segments but not seeing them live in the editor view is leagues away from the direct operator in terms of speed and usability. Adding the ability to increase the number of loop cuts with the mouse wheel while LMB button is down would be good already. @William Reynish (billreynish) Can this be done? It's not conflicting with mouse-wheel zoom since that's not possible when LMB is pressed down in that mode anyway.

@Cezary Szadejko (cez) I don't like toggles that much, I'd rather know exactly what I get when I press a key, regardless how many times I press it.
Can't remember any program that uses Ctrl + Q to close on Windows. Might be different on other platforms of course.
Ctrl + D for deselect would also be pretty nice from an ergonomic perspective but I that is used for Duplicate.

i want to ask what id the real difference bewteen these two?, wouldn't be ideal to replace the Transform tools with the pop-over ones ,so they can be used with the industry hotkeys and work with other Active Tools epsecially selection tools and i beleive it will even bring 2.79 functioanlity to be easily toggleable....and the pop-over can remain for the other options.

Yes, that would be the main Ideea, now we only need @William Reynish (billreynish) to change those :) .
I think Pablo said that the " move, rotate, scale - TOOLS " will be obsolete and be removed .

i want to ask what id the real difference bewteen these two?, wouldn't be ideal to replace the Transform tools with the pop-over ones

No, they are different, With the "real" transform tools you can click and drag anywhere to transform, which is a top feature. The "overlay" gizmos are great to help the tools that doesn't have gizmos, like the selection tools, so you can for example box select and still have the gizmo available etc... They both need to exist.

Zino Guerr (Zino) added a comment.EditedApr 24 2019, 2:32 PM

i want to ask what id the real difference bewteen these two?, wouldn't be ideal to replace the Transform tools with the pop-over ones

No, they are different, With the "real" transform tools you can click and drag anywhere to transform, which is a top feature. The "overlay" gizmos are great to help the tools that doesn't have gizmos, like the selection tools, so you can for example box select and still have the gizmo available etc... They both need to exist.

why would u need click drag if you are using the gizmos in the first place? also isn't that the job of the select tool? so simply changing only the selection type will do the job.....i think it's redundant to have two options like this, and jumping between Active tools and pop-over, the system can be much more simpler and less confusing, this way you can combine both the transform tools and selection tools without hitting too many keys...anyway if there is no plan to change this, then at least the pop-over gizmos should be able to be bound to hotkeys so we can use them instead of the Transform tools.

i want to ask what id the real difference bewteen these two?, wouldn't be ideal to replace the Transform tools with the pop-over ones

No, they are different, With the "real" transform tools you can click and drag anywhere to transform, which is a top feature. The "overlay" gizmos are great to help the tools that doesn't have gizmos, like the selection tools, so you can for example box select and still have the gizmo available etc... They both need to exist.

But...If you choose the "Select Tool" the click and drag behavior is still there. So if drag anywhere is what you want, switch to that tool. Also if you set a shortcut for the move, rotate, and scale operators (2.79 method) to click drag, you get this behavior as well.

why would u need click drag if you are using the gizmos in the first place?

Clicking on the gizmo widget is not always the best way of working. It lacks precision and can be a slow workflow. That's why we need both.

But...If you choose the "Select Tool" the click and drag behavior is still there. So if drag anywhere is what you want, switch to that tool. Also if you set a shortcut for the move, rotate, and scale operators (2.79 method) to click drag, you get this behavior as well.

The select tool can't do "drag anywhere" for scale or rotate. And assign shortcuts for modal tools doesn't make sense when using active tools.

Zino Guerr (Zino) added a comment.EditedApr 25 2019, 3:29 AM

@TheRedWaxPolice (TheRedWaxPolice) personally i use box select on RMB click drag and hotkeys for transform tools even have cycling transform tools with a hotkey , this way not only i can select but also click drag with manipulators on LMB and they don't interfere with selecting components pretty much like "Right click select".... i know this is unorthodox way but i found it much more intuitve and fast the only thing is missing is to be able to toggle transform tools that's all what i am looking for either from the Active tools or the pop-over ones if we can map anyone of them to our own hotkeys then they can both stay since not all of us find this little problem annoying.

The problems with those tools is that, they don't behave like " standard " DCC apps. So :

  • When I'm in move tool mode I should be able to box select and deselect everything, keeping the move Tool On.
  • The same is in rotate and scale mode .

Right now the behavior is :
I go into vertex/face/edge mode and when I'm in MoveTool Mode I can't deselect, because moving It's always on . I have to get back into box select mode to deselect. This is unwanted behavior in "standard" DCC apps .

The only way now that I've figured out that behaves like in all the DCC apps is not using the Move/Scale/Rotate Tools. And use the newly added Transform Gizmos .

That should be able to be supported like so:

When any of the transform tools are enabled:

  • drag LMB anywhere to box select
  • drag MMB anywhere to transform
  • drag LMB on gizmos to transorm (obviously)

Maya works something like this, and it should be easy to addresss here.

You can now box select while the transform tools are active, just like in Maya.

Left-click and drag to box select. Middle-mouse drag to use transform tool outside the gizmo.

You can now box select while the transform tools are active, just like in Maya.
Left-click and drag to box select. Middle-mouse drag to use transform tool outside the gizmo.

@William Reynish (billreynish) Thank you, that was bothering me.

Hey William, this is a lot better now especially with the middle mouse button.
One small issue though. If you want to move the object by 5 units in X, you have to click MMB once, move the mouse slightly then hit X, then 5 and enter.
Would it be possible to not move the mouse slightly or would it interfere with something else?

Also, TAB seems to be operator search in every editor. It would make more sense to have it as "node search" rather then operator search in the shader and comp editor.

Will some original blender shortcuts make a return in this one like the add menu or TAB for edit in 3dview?

It seems the buildbot didn't updated. I've downloaded a new build and it's still the same :( .

Hey William, this is a lot better now especially with the middle mouse button.
One small issue though. If you want to move the object by 5 units in X, you have to click MMB once, move the mouse slightly then hit X, then 5 and enter.

That is because the modal keymap is only active while moving. There's no real way around this.

Would it be possible to not move the mouse slightly or would it interfere with something else?

It would. It's both technically tricky but also would make it impossible to use the keyboard to change tools, if the keyboard is being used to make adjustments to the current tool.

Also, TAB seems to be operator search in every editor. It would make more sense to have it as "node search" rather then operator search in the shader and comp editor.

Maybe it could invoke the Add menu here, but really that would be rather inconsistent.

Will some original blender shortcuts make a return in this one like the add menu or TAB for edit in 3dview?

The modes are set to the number keys.

I didn´t mean the Add menu itself, I meant the search item in the add menu in the node editor. This is the way it is in Nuke, Maya etc. You hit TAB and directly type in what you are looking for.
Anyway, if that is not possible, and since shift+A is still used for the add menu in the node editor, wouldn´t it be more consistent to have shift+A for the add menu in the 3d view as well?

It seems the buildbot didn't updated. I've downloaded a new build and it's still the same :( .

Oh I am building blender myself. Sorry :)

William, there seems to something wrong with the T and N panel. I can´t seem to activate them via their hotkeys nor drag them out with the mouse. Just with the menu entry and when that is done once, it works using the mouse again yet still no luck with the hotkeys.

Hi , for toggle quad view and return in any view shortcut please . Thank you .

It seems the buildbot didn't updated. I've downloaded a new build and it's still the same :( .

Oh I am building blender myself. Sorry :)
William, there seems to something wrong with the T and N panel. I can´t seem to activate them via their hotkeys nor drag them out with the mouse. Just with the menu entry and when that is done once, it works using the mouse again yet still no luck with the hotkeys.

Those are two separate things. I assume you are referring to the Toolbar and Sidebar, which happen to be assigned to the T and N keys in the default keymap. In this keymap they aren't bound to those keys.

As for the arrow, it's a bug bug not related to keymaps.

Sorry for being unclear. I meant the Toolbar and Sidebar and according to the menu entry, they are assigned to CTRL [ and CTRL ] which don´t work on my German keyboard layout.

Sorry for being unclear. I meant the Toolbar and Sidebar and according to the menu entry, they are assigned to CTRL [ and CTRL ] which don´t work on my German keyboard layout.

I experienced the same at first, but then found out that you have to press the keys at the same location as [ and ] on the US layout instead of the same character, which would be ? and ` (to two keys to the right of backspace).

And I have to support adding Shift + A to the 3dView (as mentioned several times already by me, but it hasn't been answered so far :( ).

@Michael Klement (zaha): do any other apps use Shift-A to add new items or primitives?

Catalin (giakaama) added a comment.EditedApr 26 2019, 9:38 AM

@Michael Klement (zaha): do any other apps use Shift-A to add new items or primitives?

Nope, In modo usualy you bind a shortcut to each primitive if you want to speed it up. The rest are the same bind shortcuts or press the menu button .

(EDIT)

Usualy there is only 1 click to produce the primitive. In blender there are 2
Shift+A then click on the primitive

In other apps the primitives are usualy in the main menu so it's just 1 click and 1m x 1m cube or sphere etc ... appears in the viewport .

After you made the primitive you can edit it :) .

It's ok even with Shift+A then click ... my oppinion if you want to go faster ... move the Shift+A menu on RightClick when in Object Mode .
Like in Silo 3D

And If it's not a bother can you please put

1 For Vertex Mode
2 For Edge Mode
3 For Face Mode
4 For Object Mode
?

EX in Modo 4 it's for Select By Material and 5 Is for object mode :) ( I know I can change them myself )

@Michael Klement (zaha): do any other apps use Shift-A to add new items or primitives?

@William Reynish (billreynish) I'm not that familiar with the other apps but as Catalin said they usually have a button in the UI to add primitives with 1 click. Since it's a very useful shortcut and does not conflict with anything, why not copy this from blenders default keymap?
Right now you have to click, dig down into a cascading menu and click again, making this rather slow for such a common operation. The same principle as with the mesh editing tools should apply here to keep this on an easy to reach key.

Oskar (Oskar) added a comment.EditedApr 26 2019, 12:36 PM

This bug is still present here with the ICKeymap.
Seems like the Knife Tool works as if the LMB is always pressed.
It creates a point every time you hover over an edge (without clicking).

Do you guys experience the same thing?

PS:
OK, I found a fix.
For Add Cut we need to set the Left Mouse click to "Any".

I found a fix.
For Add Cut we need to set the Left Mouse click to "Any".

@William Sitton (william) Reynish (billreynish)
Thank you William this keymap is getting better and better.
Just one thing
I don't know if it's possible, but I think can be a good improvement.

Current behaviour:


My proposal

And I still missing an easy way for edge ring selection.

How do various apps let you select edge rings? If there’s a good way that fits and causes no apparent conflicts I am happy to add it.

I'd say the usual workflow is for you to select one edge and then double click another edge in the direction of the ring. Generally speaking if you double click on the very next edge on the ring it will give you a full ring and if you click on a few edges down in the ring it will give you a partial ring bound by your 2 edges. This last workflow is also the same for loops

In case of 3ds Max it's selecting another mesh element next to the one already selected in the direction of the ring while holding Shift. Or Ctrl+R.

Also, as I said already - Alt+LMB is the most obvious solution, but you've closed the door for using it without conflict by ignoring T62154

Right now It's good but, it can be better :) .

I know I insist with Modo but that software got very good interaction :) . Anyway just a little bit of changes if it's possible .

The mouse interaction is :
Left Click - selects element by element ( painting selection, something like circle selection )
Middle Click - Lasoo, Box selection through the object ( with this you can select all the faces visible and occluded )
Right Click - It's Lasoo, Box selection normal style ... you can select only the visible faces

I realy think right now blender it's ok, maybe if it's possible ...
Left Click - box select/circle/lasoo
MiddleClick - maybe we can add the select through
Right Click - you can have the context menu that appears with CLICK - Release , and with CLICK -Pressed and drag you can have the moving functionality it's right now :)

About the edge loops and rings I find Maya way very intuitive.
Everything here is just Shift + Double Left Click:

Neither the loop or ring select operators in Blender currently work this way, so it’s outaide of the scope of the keymap to do it that way.

Can you add select behind (vertex-edge-face) without using xray ?
I found this really slow my work each time I need to enable xray to select behind. is there away to add an option to select behind ?
any software let you have this option I hope to add this option for blender too.

This comment was removed by Alex (Alex108).

Can we have separate industry standard navigation (Alt+click movement and basics) and Blender default keymap at the same time? Industry compatible option is currently frustrating for existing Blender users who also use Maya etc - when you were given a familiar alt+click navigation but you're completely lost in new hotkeys... Although I use many apps, I only set Alt-navigation and F for the center in Blender because my muscle memory has already remembered default Blender keymap for years. The only thing which irritates me a lot is that still when you try to orbit with Alt-LMB when the cursor is hovering on any object, you move the object instead of orbiting. So in a dense scene, you can't even orbit. I'm not sure if it happens when Industry compatible is ON, but when you set your own keys it does, and it's frustrating.

That's kinda what I have in my setup. I left as many defaults as I "could". Mostly focusing around Maya Alt-Navigation; and various selections.
If you feel adventurous to try it out, here's the link:
https://blenderartists.org/t/input-custom-blender-setup-alt-maya-navigation-lmb-selections-for-blender-2-80/1136954

I recently wrote about having separate options: Industry compatible keymap and navigation because some people prefer Alt-click navigation but got used to default Blender keymap. But then deleted it because actually the current Industry compatible keymap is not that bad and lots of key bindings make sense. I only added a few for now:

  • F11 - toggle Renderview
  • Home - Jump to the first frame
  • End - jump to the last frame
  • Spacebar - Toggle Maximize Area (like Nuke and Katana)
  • L - play animation forward (Davinci, YouTube)
  • J - play animation backward (Davinci, YouTube)
  • Ctrl+J - join objects

Can we have separate industry standard navigation (Alt+click movement and basics) and Blender default keymap at the same time? Industry compatible option is currently frustrating for existing Blender users who also use Maya etc - when you were given a familiar alt+click navigation but you're completely lost in new hotkeys... Although I use many apps, I only set Alt-navigation and F for the center in Blender because my muscle memory has already remembered default Blender keymap for years. The only thing which irritates me a lot is that still when you try to orbit with Alt-LMB when the cursor is hovering on any object, you move the object instead of orbiting. So in a dense scene, you can't even orbit. I'm not sure if it happens when Industry compatible is ON, but when you set your own keys it does, and it's frustrating.

Same here, all I really care about is Maya-style Navigation and WER for the transform tools. Those are the major pain points. For the rest, I don't care that much as long as it's functional and lends itself to a good user experience.

Right now, the industry standard keymap sacrifices too much on the altar of strictly adhering to the industry apps in my opinion. It's missing functionality and effectiveness that is there in the Blender default keymap. Overall it's too reliant on the mouse which makes it slow. I tried to address this with my feedback, but most of it has been either ignored or rejected with the argument that it's not following other industry standard apps. :(

I will still follow it's development to see how it turns out in th end, but sadly I get more and more inclined to go with a modified Blender default keymap. Might try out @0rAngE (undo)'s keymap as well but I would've preferrred to stick with an official keymap.

Honestly, while I applaud the effort, I see this as taking a half measure when you needed to take a whole. Imagine being a Maya user, and opening Blender for the first time. You've heard 2.8 is great, so you fire up the program.

You have two options:

  1. Use the default Blender settings, and have to re-learn everything you've gotten used to from scratch, because Blender insists on being weird and idiosyncratic and doesn't conform to the standards 95% of other programs use
  1. Use the "Industry Standard Keymap", which works great... until you have to google something for help, and you find that all the forum discussions and stackexchange posts and tutorials are based around the default settings. Now you have to go through the additional step of trying to translate what they're saying and work out how to do it with your non-standard keymap.

Eventually, after several days of this, it looks real tempting to just quit and go back to Maya.

I think the best approach is just to bite the bullet and change the default settings , while allowing old users to revert to the Legacy settings if they feel like it.

I think the Blender developers need to start seeing the industry as a whole as its target audience, instead of serving the whims of its current users at the expense of everyone else. I'm glad to see you've already started doing this with the Left-Click Select, Drag box select and the Spacebar key. But I think you need to go one step further and move to the WER/manipulator tool approach and Alt-Click standard.

Can you add select behind (vertex-edge-face) without using xray ?
I found this really slow my work each time I need to enable xray to select behind. is there away to add an option to select behind ?
any software let you have this option I hope to add this option for blender too.

It would be great to have this, but I guess it isn't part of the keymap.

Currently as a workaround it can be achieved with a custom Macro operator.
When you click and drag instead of starting the box select it first triggers xray mode, then box select and after you release the button it disables the xray mode.



You can load this as an addon and add it in the keymap.
In 3D View -> 3D View (Global) and 3D View -> Object Mode -> 3D View Tool: Move/Rotate/Scale
add this:

os.select_through

as Tweek | Left Mouse | Any multiple times for the different selection functions with Ctrl/Shift/Ctrl+Shift etc and change the settings for the selection Mode.

Lots of these posts are general Blender feature requests and are outside the scope of the keymap. A keymap can only change the keyboard mappings, and cannot add entirely new features in Blender.

Honestly, while I applaud the effort, I see this as taking a half measure when you needed to take a whole. Imagine being a Maya user, and opening Blender for the first time. You've heard 2.8 is great, so you fire up the program.
You have two options:

  1. Use the default Blender settings, and have to re-learn everything you've gotten used to from scratch, because Blender insists on being weird and idiosyncratic and doesn't conform to the standards 95% of other programs use
  2. Use the "Industry Standard Keymap", which works great... until you have to google something for help, and you find that all the forum discussions and stackexchange posts and tutorials are based around the default settings. Now you have to go through the additional step of trying to translate what they're saying and work out how to do it with your non-standard keymap.

Eventually, after several days of this, it looks real tempting to just quit and go back to Maya.
I think the best approach is just to bite the bullet and change the default settings , while allowing old users to revert to the Legacy settings if they feel like it.
I think the Blender developers need to start seeing the industry as a whole as its target audience, instead of serving the whims of its current users at the expense of everyone else. I'm glad to see you've already started doing this with the Left-Click Select, Drag box select and the Spacebar key. But I think you need to go one step further and move to the WER/manipulator tool approach and Alt-Click standard.

Don't think that such a dramatic change would fare well with a lot of original blender users. This keymap is doing well, if you want maya behavior then just switch to it.
Regarding the translation problem between this and legacy shortcuts I think there should at least be some solid documentation somewhere in blender help about what changes are in this keymap OR a translator addon, anyone?;)

Scrubbing the timeline doesn't work on top half of area after resizing the timeline (also graph editor, dope sheet and other animation tools). Throws "Error: animation channel (index = 1) not found in mouse_action_keys()" exception.


Here you can see me furiously trying to drag in the upper half portion of the timeline to no effect while it works as intended in the bottom. This works fine in blender keymap (right click).

@ces That issue is a Blender issue. Will be solved shortly by D4654

Unwrap doesn't have a shortcut yet.

This task was getting a bit noisy, so in order to keep developer.blender.org more focused on developers, I have started a thread on devtalk instead:

https://devtalk.blender.org/t/industry-compatible-keymap-questions-suggestions-and-answers/

So, if anyone has any questions, suggestions or comments, please direct them there instead.

Thanks.

Same behaviour "bug?" on three different computer at work.

In the above chart, it would be nice to be able to see the default Blender keys... Should be easy to add.
Thanks.
Stephen

So is the idea that Blender 2.8 will have the "Winner" column for the navigation controls? Because the most recent one I downloaded does not... and it is practically un-useable from someone coming from Maya.. It just slows stuff down so much.

@Michael Murdock (opafaf) this is a separate keymap. Select it in Edit > Preferences > Keymap

"Loop cut" in Cinema 4D is "Alt+X" (In a newer version, it's change to "M-M").